#include "STC32G.h"
#include "can.h"
/****************************** û ***********************************/
//CAN߲=Fclk/((1+(TSG1+1)+(TSG2+1))*(BRP+1)*2)
#define TSG1    2		//0~15
#define TSG2    1		//1~7 (TSG2 Ϊ0)
#define BRP     3		//0~63
//24000000/((1+3+2)*4*2)=500KHz

#define SJW     0		//ͬԾ

//߲100KHzΪ 0; 100KHzΪ 1
#define SAM     0		//ߵƽ 0:1; 1:3

/*****************************************************************************/
u16 CAN_ID = 0X345;
u8 RX_BUF[8];
u8 TX_BUF[8];
bit B_Can1Read;     //CAN յݱ־
bit B_Can2Read;     //CAN յݱ־
bit B_Can1Send;     //CAN ݱ־
bit B_Can2Send;     //CAN ݱ־
//========================================================================
// : u8 ReadReg(u8 addr)
// : CANܼĴȡ
// : CANܼĴַ.
// : CANܼĴ.
// 汾: VER1.0
// : 2020-11-16
// ע: 
//========================================================================
u8 CanReadReg(u8 addr)
{
	u8 dat;
	CANAR = addr;
	dat = CANDR;
	return dat;
}
//========================================================================
// : void WriteReg(u8 addr, u8 dat)
// : CANܼĴú
// : CANܼĴַ, CANܼĴ.
// : none.
// 汾: VER1.0
// : 2020-11-16
// ע: 
//========================================================================
void CanWriteReg(u8 addr, u8 dat)
{
	CANAR = addr;
	CANDR = dat;
}

void CanReadFifo(u8 *pdat)
{
  pdat[0] = CanReadReg(RX_BUF0);
	pdat[1] = CanReadReg(RX_BUF1);
	pdat[2] = CanReadReg(RX_BUF2);
	pdat[3] = CanReadReg(RX_BUF3);
	
  pdat[4] = CanReadReg(RX_BUF0);
	pdat[5] = CanReadReg(RX_BUF1);
	pdat[6] = CanReadReg(RX_BUF2);
	pdat[7] = CanReadReg(RX_BUF3);

  pdat[8] = CanReadReg(RX_BUF0);
	pdat[9] = CanReadReg(RX_BUF1);
	pdat[10] = CanReadReg(RX_BUF2);
	pdat[11] = CanReadReg(RX_BUF3);

  pdat[12] = CanReadReg(RX_BUF0);
	pdat[13] = CanReadReg(RX_BUF1);
	pdat[14] = CanReadReg(RX_BUF2);
	pdat[15] = CanReadReg(RX_BUF3);	
}
//*********************************************//
u16 CanReadMsg(u8 *pdat)
{
 u8 i;
 u16 CanID;
 u8 buffer[16];
 CanReadFifo(buffer);
	CanID = ((buffer[1]<<8)+buffer[2])>>5;
	for(i=0;i<8;i++)
	{
	  pdat[i] = buffer[i+3];
	}
	return CanID;
}
//*************************************************//
void CanSendMsg(u16 canid,u8 *pdat)
{
  u16 CanID;
	CanID = canid<<5;
	CanWriteReg(TX_BUF0,0X08);
  CanWriteReg(TX_BUF1,(u8)(CanID>>8));
  CanWriteReg(TX_BUF2,(u8)CanID);
	CanWriteReg(TX_BUF3,pdat[0]);

	CanWriteReg(TX_BUF0,pdat[1]);
	CanWriteReg(TX_BUF1,pdat[2]);
	CanWriteReg(TX_BUF2,pdat[3]);
	CanWriteReg(TX_BUF3,pdat[4]);	
	
	CanWriteReg(TX_BUF0,pdat[5]);
	CanWriteReg(TX_BUF1,pdat[6]);
	CanWriteReg(TX_BUF2,pdat[7]);
	
	CanWriteReg(TX_BUF3,0x00);	
	CanWriteReg(CMR,0x04);
}
//========================================================================
// : void CANSetBaudrate()
// : CAN߲ú
// : none.
// : none.
// 汾: VER1.0
// : 2020-11-19
// ע: 
//========================================================================
void CANSetBaudrate()
{
	CanWriteReg(BTR0,(SJW << 6) + BRP);
	CanWriteReg(BTR1,(SAM << 7) + (TSG2 << 4) + TSG1);
}

//========================================================================
void CanInit()
{
	CANEN = 1;          //CAN1ģʹ
	CANSEL = 0;         //ѡCAN1ģ
//	P_SW1 = (P_SW1 & ~(3<<4)) | (0<<4); //˿л(CAN_Rx,CAN_Tx) 0x00:P0.0,P0.1  0x10:P5.0,P5.1  0x20:P4.2,P4.5  0x30:P7.0,P7.1
  P_SW1 = 0;
	CanWriteReg(MR  ,0x04);		//ʹ Reset Mode
	CANSetBaudrate();	//ò
	
	CanWriteReg(ACR0,0x00);		//մĴ
	CanWriteReg(ACR1,0x00);
	CanWriteReg(ACR2,0x00);
	CanWriteReg(ACR3,0x00);
	CanWriteReg(AMR0,0xFF);		//μĴ
	CanWriteReg(AMR1,0xFF);
	CanWriteReg(AMR2,0xFF);
	CanWriteReg(AMR3,0xFF);

	CanWriteReg(IMR ,0xff);		//жϼĴ
	CanWriteReg(ISR ,0xff);		//жϱ־
	CanWriteReg(MR  ,0x00);		//˳ Reset Mode
	CANICR = 0x02;				//CANжʹ
	AUXR2 |= 0X02;
}
void Can2Init()
{
	CAN2EN = 1;          //CAN2ģʹ
	CANSEL = 1;         //ѡCAN1ģ

	P_SW3 = 0;
	CanWriteReg(MR  ,0x04);		//ʹ Reset Mode
	CANSetBaudrate();	//ò
	
	CanWriteReg(ACR0,0x00);		//մĴ
	CanWriteReg(ACR1,0x00);
	CanWriteReg(ACR2,0x00);
	CanWriteReg(ACR3,0x00);
	CanWriteReg(AMR0,0xFF);		//μĴ
	CanWriteReg(AMR1,0xFF);
	CanWriteReg(AMR2,0xFF);
	CanWriteReg(AMR3,0xFF);

	CanWriteReg(IMR ,0xff);		//жϼĴ
	CanWriteReg(ISR ,0xff);		//жϱ־
	CanWriteReg(MR  ,0x00);		//˳ Reset Mode
	CANICR = 0x02;				//CANжʹ
	AUXR2 |= 0X02;
}
//========================================================================
// : void CANBUS1_Interrupt(void) interrupt CAN1_VECTOR
// : CANжϺ
// : none.
// : none.
// 汾: VER1.0
// : 2022-03-24
// ע: 
//========================================================================
void CANBUS1_Interrupt(void) interrupt CAN1_VECTOR
{
	u8 isr;
	u8 store;
	u8 arTemp;

	arTemp = CANAR;     //CANARֳ棬ѭд CANAR жϣж޸ CANAR 
	store = AUXR2;      //AUXR2ֳ
	
	AUXR2 &= ~0x08;		//ѡCAN1ģ
	isr = CanReadReg(ISR);

	if((isr & 0x04) == 0x04)  //TI
	{
		CANAR = ISR;
		CANDR = 0x04;    //CLR FLAG
		
		B_Can1Send = 0;
	}	
	if((isr & 0x08) == 0x08)  //RI
	{
		CANAR = ISR;
		CANDR = 0x08;    //CLR FLAG

		B_Can1Read = 1;
	}

	if((isr & 0x40) == 0x40)  //ALI
	{
		CANAR = ISR;
		CANDR = 0x40;    //CLR FLAG
	}	

	if((isr & 0x20) == 0x20)  //EWI
	{
		CANAR = MR;
		CANDR &= ~0x04;  // Reset Mode, BUS-OFF״̬˳
		
		CANAR = ISR;
		CANDR = 0x20;    //CLR FLAG
	}	

	if((isr & 0x10) == 0x10)  //EPI
	{
		CANAR = ISR;
		CANDR = 0x10;    //CLR FLAG
	}	

	if((isr & 0x02) == 0x02)  //BEI
	{
		CANAR = ISR;
		CANDR = 0x02;    //CLR FLAG
	}	

	if((isr & 0x01) == 0x01)  //DOI
	{
		CANAR = ISR;
		CANDR = 0x01;    //CLR FLAG
	}	

	AUXR2 = store;     //AUXR2ֳָ
	CANAR = arTemp;    //CANARֳָ
}

//========================================================================
// : void CANBUS2_Interrupt(void) interrupt CAN2_VECTOR
// : CANжϺ
// : none.
// : none.
// 汾: VER1.0
// : 2020-11-19
// ע: 
//========================================================================
void CANBUS2_Interrupt(void) interrupt CAN2_VECTOR
{
	u8 isr;
	u8 store;
	u8 arTemp;

	arTemp = CANAR;     //CANARֳ棬ѭд CANAR жϣж޸ CANAR 
	store = AUXR2;      //AUXR2ֳ
	
	AUXR2 |= 0x08;		//ѡCAN2ģ
	isr = CanReadReg(ISR);

	if((isr & 0x04) == 0x04)  //TI
	{
		CANAR = ISR;
		CANDR = 0x04;    //CLR FLAG
		
		B_Can2Send = 0;
	}	
	if((isr & 0x08) == 0x08)  //RI
	{
		CANAR = ISR;
		CANDR = 0x08;    //CLR FLAG
	P13 = 0;
		B_Can2Read = 1;
	}

	if((isr & 0x40) == 0x40)  //ALI
	{
		CANAR = ISR;
		CANDR = 0x40;    //CLR FLAG
	}	

	if((isr & 0x20) == 0x20)  //EWI
	{
		CANAR = MR;
		CANDR &= ~0x04;  // Reset Mode, BUS-OFF״̬˳
		
		CANAR = ISR;
		CANDR = 0x20;    //CLR FLAG
	}	

	if((isr & 0x10) == 0x10)  //EPI
	{
		CANAR = ISR;
		CANDR = 0x10;    //CLR FLAG
	}	

	if((isr & 0x02) == 0x02)  //BEI
	{
		CANAR = ISR;
		CANDR = 0x02;    //CLR FLAG
	}	

	if((isr & 0x01) == 0x01)  //DOI
	{
		CANAR = ISR;
		CANDR = 0x01;    //CLR FLAG
	}	

	AUXR2 = store;     //AUXR2ֳָ
	CANAR = arTemp;    //CANARֳָ
}











